; 
    include \masm32\include\masm32rt.inc
; 

    include lib\ctree.inc
    includelib lib\ctree.lib

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    .code

start:
  
; 

    call main

    exit

; 

main proc

    LOCAL pfile :DWORD                      ; file memory pointer
    LOCAL flen  :DWORD                      ; file length
    LOCAL ptree :DWORD                      ; tree memory pointer
    LOCAL cloc  :DWORD                      ; tree current location

    LOCAL tc0   :DWORD
    LOCAL tc1   :DWORD
    LOCAL tc2   :DWORD
    LOCAL tc3   :DWORD

    LOCAL pcmd  :DWORD                      ; command line pointer
    LOCAL buffer[260]:BYTE                  ; command line buffer

    push ebx
    push esi
    push edi

    mov pcmd, ptr$(buffer)                  ; cast buffer to pointer

    cmp rv(GetCL,1,pcmd), 1
    je @F
    print "No command line file",13,10
    ret
  @@:
    cmp rv(exist,pcmd), 1
    je @F
    print "cannot find that file",13,10
    ret
  @@:

    mov pfile, InputFile(pcmd)
    mov flen, ecx
    mov ptree, alloc$(rv(IntMul,ecx,12))    ; allocate file length * 12
    mov pcmd, ptr$(buffer)                  ; reuse command line buffer

    mov tc0, rv(GetTickCount)

  ; ----------------------------------------
  ; run first loop to get loop timing
  ; ----------------------------------------

    mov esi, pfile
    mov edi, pcmd
    xor ebx, ebx

  @@:
    mov al, [esi]
    add esi, 1
    test al, al
    jz wout0
    cmp al, 13
    je sbr0
    mov [edi], al
    add edi, 1
    jmp @B
  sbr0:
    mov BYTE PTR [edi], 0
    ;; add ebx, 1
    ;; cmp rv(insert_data,pcmd,ptree,ADDR cloc,ebx), -1
    mov edi, pcmd
    add esi, 1
    jmp @B

  wout0:
    mov BYTE PTR [edi], 0
    ;; add ebx, 1
    ;; cmp rv(insert_data,pcmd,ptree,ADDR cloc,ebx), -1

    mov tc1, rv(GetTickCount)

  ; ----------------------------------------

    mov esi, pfile
    mov edi, pcmd
    xor ebx, ebx

  @@:
    mov al, [esi]
    add esi, 1
    test al, al
    jz wout
    cmp al, 13
    je sbr
    mov [edi], al
    add edi, 1
    jmp @B
  sbr:
    mov BYTE PTR [edi], 0
    add ebx, 1
    cmp rv(insert_data,pcmd,ptree,ADDR cloc,ebx), -1
    mov edi, pcmd
    add esi, 1
    jmp @B

  wout:
    mov BYTE PTR [edi], 0
    add ebx, 1
    cmp rv(insert_data,pcmd,ptree,ADDR cloc,ebx), -1

    mov tc2, rv(GetTickCount)

  ; ----------------------------------------

    mov esi, pfile
    mov edi, pcmd
    xor ebx, ebx

  @@:
    mov al, [esi]
    add esi, 1
    test al, al
    jz wout1
    cmp al, 13
    je sbr1
    mov [edi], al
    add edi, 1
    jmp @B
  sbr1:
    mov BYTE PTR [edi], 0
    cmp rv(test_data,pcmd,ptree), -1

    mov edi, pcmd
    add esi, 1
    jmp @B

  wout1:
    mov BYTE PTR [edi], 0
    cmp rv(test_data,pcmd,ptree), -1

    mov tc3, rv(GetTickCount)

  ; ----------------------------------------

    mov ecx, tc1
    sub ecx, tc0

    push ecx
    print str$(ecx)," milliseconds loop duration",13,10
    pop ecx


    mov eax, tc2
    sub eax, tc1
    sub eax, ecx
    print str$(eax)," milliseconds load table",13,10

    mov ecx, tc1
    sub ecx, tc0

    mov eax, tc3
    sub eax, tc2
    sub eax, ecx
    print str$(eax)," milliseconds read table",13,10

    free$ ptree
    free pfile

    mov ecx, input(13,10,"Press ENTER to exit ",62," ")

    pop edi
    pop esi
    pop ebx

    ret

main endp

; 

end start